# simple test suite for testing the bindings
# status: incomplete .. :(

import unittest
from libid3tag import *
import os

testmp3 = "test.mp3"

class ID3TagFileTestCase(unittest.TestCase):
    def setUp(self):
	assert os.path.exists(testmp3), "Test MP3 %s missing" % testmp3
    def tearDown(self):
	if self.file:
	    id3_file_close(self.file)
	    
    def testFileOpen(self):
	self.file = id3_file_open(testmp3, ID3_FILE_MODE_READONLY)
	assert self.file, "Unable to open MP3 as READONLY"
	retval = id3_file_close(self.file)
	assert retval != 0, "Failed closing READONLY file"
	self.file = id3_file_open(testmp3, ID3_FILE_MODE_READWRITE)
	assert self.file, "Unable to open MP3 as READWRITE"
	retval = id3_file_close(self.file)
	assert retval != 0, "Failed closing READWRITE file"
	
    def testFileUpdate(self):
	self.file = id3_file_open(testmp3, ID3_FILE_MODE_READWRITE)
	retval = id3_file_update(self.file)
	assert retval != 0, "Failed to update in READWRITE"
	retval = id3_file_close(self.file)	
	self.file = id3_file_open(testmp3, ID3_FILE_MODE_READONLY)
	retval = id3_file_update(self.file)
	assert retval != -1, "No Error when attempting to update in READONLY"
	retval = id3_file_close(self.file)		
	
    def testFileTag(self):
	self.file = id3_file_open(testmp3, ID3_FILE_MODE_READWRITE)
	tag = id3_file_tag(self.file)
	assert tag, "Unable to get ID3 Tag"
	id3_file_close(self.file)
	

class ID3TagTagTestCase(ID3TagFileTestCase):
    def setUp(self):
	ID3FileTestCase.setUp()
	self.file = id3_file_open(testmp3, ID3_FILE_MODE_READWRITE)
	assert self.file, "Unable to open file"
	self.tag = id3_file_tag(self.file)
	assert self.tag, "Unable to open tag"
	
    def tearDown(self):
	if self.file:
	    id3_file_close(self.file)
	
    def testVersion(self):
	version = id3_tag_version(self.tag)
	assert version, "Unable to get version"
	
    def testOptions(self):
	options = id3_tag_options(self, ID3_TAG_OPTION_COMPRESS, 1)
	assert options != -1, "Unable to use options"
	

class ID3TagFrameTestCase(ID3TagTagTestCase):
    def setUp(self):
	ID3TagTagTestCase.setUp()
	self.frame = id3_tag_findframe(self.tag, ID3_FRAME_TITLE, 0)

    def testGetField(self):
	self.field = id3_frame_field(self.frame, 1)
	assert self.field, "Unable to get field"
	
class ID3TagFieldTestCase(ID3TagFrameTestCase):
    
    def testGetInt(self):
	field = id3_frame_field(self.frame, 0)
	retval = id3_field_getint(field)
	assert retval != -1, "Unable to get int"

    def testGetStrings(self):
	field = id3_frame_field(self.frame, 1)
	retval = id3_field_getstrings(field, 0)
	assert retval, "Unable to get string"

    def testSetStrings(self):
	field = id3_frame_field(self.frame, 1)
	retval = id3_field_setstrings(field, ["abcde"])
	assert retval, "Unable to set string"
